#include "SDL.h"

int main(int argc, char *argv[]) {
    SDL_Window *win = NULL;
    SDL_Renderer *renderer = NULL;
    SDL_Texture *bitmapTex = NULL;
    SDL_Surface *bitmapSurface = NULL;

    SDL_Init(SDL_INIT_VIDEO);

    win = SDL_CreateWindow("FS WINDOW", 0, 0, 0, 0, SDL_WINDOW_FULLSCREEN_DESKTOP|SDL_WINDOW_MOUSE_FOCUS );

    renderer = SDL_CreateRenderer(win, -1, SDL_RENDERER_ACCELERATED);
    SDL_RenderSetLogicalSize(renderer, 320, 200); 

    bitmapSurface = SDL_LoadBMP("hello.bmp");
    bitmapTex = SDL_CreateTextureFromSurface(renderer, bitmapSurface);
    SDL_FreeSurface(bitmapSurface);

    int win_width, win_height, mx, my, area_width;
    area_width = 640;
    SDL_GetWindowSize (win, &win_width, &win_height);
    printf ("Window dimensions %d x %d\n", win_width, win_height);

    int r_limit = win_width/2 + area_width/2;
    int l_limit = win_width/2 - area_width/2;

    SDL_ShowCursor(SDL_ENABLE);
    //SDL_SetWindowGrab(win, SDL_TRUE);
    //SDL_SetRelativeMouseMode(SDL_TRUE);

    while (1) {
        SDL_Event e;
        if (SDL_PollEvent(&e)) {
		if (e.type == SDL_KEYDOWN) {
			break;
		}
	}

	SDL_GetMouseState(&mx, &my);
	printf ("Mouse coords %d,%d\n", mx, my);

	if (mx >= r_limit) {
		SDL_WarpMouseInWindow(win, r_limit, my);
	}
	if (mx <= l_limit) {
		SDL_WarpMouseInWindow(win, l_limit, my);
	}

        SDL_RenderClear(renderer);
        SDL_RenderCopy(renderer, bitmapTex, NULL, NULL);
        SDL_RenderPresent(renderer);
    }

    SDL_DestroyTexture(bitmapTex);
    SDL_DestroyRenderer(renderer);
    SDL_DestroyWindow(win);

    SDL_Quit();

    return 0;
}

